"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_extra_1 = __importStar(require("fs-extra"));
var path_1 = __importDefault(require("path"));
var os_1 = __importDefault(require("os"));
var execa_1 = __importDefault(require("execa"));
var nock_1 = __importDefault(require("nock"));
var expect_1 = __importDefault(require("expect"));
var download_center_1 = require("./download-center");
describe('download center client', function () {
    var containerId;
    var tempDir;
    var bucketConfig;
    var downloadCenter;
    before(function () { return __awaiter(void 0, void 0, void 0, function () {
        var key, secret, dockerRunStdout, endpoint;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fs_extra_1.default.mkdtemp(path_1.default.join(os_1.default.tmpdir(), 'download-center-tests-'))];
                case 1:
                    tempDir = _a.sent();
                    key = 'AKIAIOSFODNN7EXAMPLE';
                    secret = 'wJalrXUtnFEMI/K7MDENG/bPxRfiCYEXAMPLEKEY';
                    return [4 /*yield*/, execa_1.default('docker', [
                            'run',
                            '--rm',
                            '-d',
                            '-P',
                            '-e',
                            "MINIO_ACCESS_KEY=" + key,
                            '-e',
                            "MINIO_SECRET_KEY=" + secret,
                            '-v',
                            tempDir + ":/data",
                            'minio/minio:edge',
                            'server', '/data'
                        ])];
                case 2:
                    dockerRunStdout = (_a.sent()).stdout;
                    containerId = dockerRunStdout;
                    return [4 /*yield*/, execa_1.default('docker', [
                            'port', containerId, '9000/tcp'
                        ])];
                case 3:
                    endpoint = (_a.sent()).stdout;
                    bucketConfig = {
                        bucket: 'test',
                        accessKeyId: key,
                        secretAccessKey: secret,
                        endpoint: endpoint,
                        sslEnabled: false,
                        s3ForcePathStyle: true
                    };
                    return [2 /*return*/];
            }
        });
    }); });
    beforeEach(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            bucketConfig.bucket = "test-" + Date.now();
            fs_extra_1.default.mkdir(path_1.default.resolve(tempDir, bucketConfig.bucket));
            downloadCenter = new download_center_1.DownloadCenter(__assign({}, bucketConfig));
            return [2 /*return*/];
        });
    }); });
    after(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, execa_1.default('docker', ['stop', containerId])];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, fs_extra_1.default.remove(tempDir)];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    var fixturePath = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return path_1.default.resolve.apply(path_1.default, __spreadArrays([__dirname, '..', 'fixtures'], args));
    };
    var bucketPath = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return path_1.default.resolve.apply(path_1.default, __spreadArrays([tempDir, bucketConfig.bucket], args));
    };
    describe('uploadAsset', function () {
        it('uploads a file', function () { return __awaiter(void 0, void 0, void 0, function () {
            var content;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, downloadCenter.uploadAsset('prefix/asset.txt', fs_extra_1.default.createReadStream(fixturePath('asset.txt')))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, fs_extra_1.default.readFile(bucketPath('prefix', 'asset.txt'), 'utf-8')];
                    case 2:
                        content = _a.sent();
                        expect_1.default(content).toEqual('content\n');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('downloadAsset', function () {
        it('downloads a file', function () { return __awaiter(void 0, void 0, void 0, function () {
            var content;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fs_extra_1.mkdirp(bucketPath('prefix'))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, fs_extra_1.default.copyFile(fixturePath('asset.txt'), bucketPath('prefix', 'asset.txt'))];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, downloadCenter.downloadAsset('prefix/asset.txt')];
                    case 3:
                        content = _a.sent();
                        expect_1.default(content === null || content === void 0 ? void 0 : content.toString()).toEqual('content\n');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('downloadConfig', function () {
        it('downloads an existing config file', function () { return __awaiter(void 0, void 0, void 0, function () {
            var config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fs_extra_1.mkdirp(bucketPath('prefix'))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, fs_extra_1.default.copyFile(fixturePath('compass.json'), bucketPath('prefix', 'compass.json'))];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, downloadCenter.downloadConfig('prefix/compass.json')];
                    case 3:
                        config = _a.sent();
                        expect_1.default(config).toHaveProperty('manual_link');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('uploadConfig', function () {
        it('uploads valid configuration', function () { return __awaiter(void 0, void 0, void 0, function () {
            var validConfig, uploadedConfig;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fs_extra_1.default.readJSON(fixturePath('compass.json'))];
                    case 1:
                        validConfig = _a.sent();
                        return [4 /*yield*/, downloadCenter.uploadConfig('prefix/compass.json', validConfig)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, fs_extra_1.default.readJSON(bucketPath('prefix', 'compass.json'))];
                    case 3:
                        uploadedConfig = _a.sent();
                        expect_1.default(uploadedConfig).toEqual(validConfig);
                        return [2 /*return*/];
                }
            });
        }); });
        it('rejects an invalid configuration (malformed)', function () { return __awaiter(void 0, void 0, void 0, function () {
            var invalidConfig, _a, error;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = [{}];
                        return [4 /*yield*/, fs_extra_1.default.readJSON(fixturePath('compass.json'))];
                    case 1:
                        invalidConfig = __assign.apply(void 0, [__assign.apply(void 0, _a.concat([(_b.sent())])), { versions: null }]);
                        return [4 /*yield*/, downloadCenter.uploadConfig('prefix/compass.json', invalidConfig).catch(function (e) { return e; })];
                    case 2:
                        error = _b.sent();
                        expect_1.default(error.message).toEqual('Invalid configuration: data.versions should be array');
                        return [2 /*return*/];
                }
            });
        }); });
        it('rejects an invalid configuration (missing link)', function () { return __awaiter(void 0, void 0, void 0, function () {
            var invalidConfig, _a, error;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = [{}];
                        return [4 /*yield*/, fs_extra_1.default.readJSON(fixturePath('compass.json'))];
                    case 1:
                        invalidConfig = __assign.apply(void 0, [__assign.apply(void 0, _a.concat([(_b.sent())])), { versions: [
                                    {
                                        '_id': '1.21.2',
                                        'version': '1.21.2 (Stable)',
                                        'platform': [
                                            {
                                                'arch': 'x64',
                                                'os': 'darwin',
                                                'name': 'OS X 64-bit (10.10+)',
                                                'download_link': 'http://example.com/non-existing-url'
                                            }
                                        ]
                                    }
                                ] }]);
                        return [4 /*yield*/, downloadCenter.uploadConfig('prefix/compass.json', invalidConfig).catch(function (e) { return e; })];
                    case 2:
                        error = _b.sent();
                        expect_1.default(error.message).toEqual('Download center urls broken:\n' +
                            '- http://example.com/non-existing-url -> 404');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('validate-config', function () {
        var links = {
            darwin: 'https://downloads.mongodb.com/compass/mongosh-0.2.2-darwin.zip',
            win32: 'https://downloads.mongodb.com/compass/mongosh-0.2.2-win32.zip',
            linux: 'https://downloads.mongodb.com/compass/mongosh-0.2.2-linux.tgz',
            debian: 'https://downloads.mongodb.com/compass/mongosh_0.2.2_amd64.deb'
        };
        var downloadCenterJson = {
            'versions': [
                {
                    '_id': '0.2.2',
                    'version': '0.2.2',
                    'platform': [
                        {
                            'arch': 'x64',
                            'os': 'darwin',
                            'name': 'MacOS 64-bit (10.10+)',
                            'download_link': links.darwin
                        },
                        {
                            'arch': 'x64',
                            'os': 'win32',
                            'name': 'Windows 64-bit (7+)',
                            'download_link': links.win32
                        },
                        {
                            'arch': 'x64',
                            'os': 'linux',
                            'name': 'Linux 64-bit',
                            'download_link': links.linux
                        },
                        {
                            'arch': 'x64',
                            'os': 'debian',
                            'name': 'Debian 64-bit',
                            'download_link': links.debian
                        }
                    ]
                }
            ],
            'manual_link': 'https://docs.mongodb.org/manual/products/mongosh',
            'release_notes_link': 'https://github.com/mongodb-js/mongosh/releases/tag/v0.2.2',
            'previous_releases_link': '',
            'development_releases_link': '',
            'supported_browsers_link': '',
            'tutorial_link': 'test'
        };
        describe('validateConfigSchema', function () {
            it('does not throw with a valid config', function () {
                expect_1.default(function () {
                    download_center_1.validateConfigSchema(downloadCenterJson);
                }).not.toThrow();
            });
            it('throws with a valid config', function () {
                var invalidConfig = __assign(__assign({}, downloadCenterJson), { manual_link: undefined });
                expect_1.default(function () {
                    download_center_1.validateConfigSchema(invalidConfig);
                }).toThrowError('Invalid configuration: data should have' +
                    ' required property \'manual_link\'');
            });
        });
        describe('validateConfigUrls', function () {
            function nockLink(link, status, headers) {
                if (headers === void 0) { headers = {}; }
                var url = new URL(link);
                nock_1.default(url.origin).head(url.pathname).reply(status, undefined, headers);
            }
            describe('when all links are correct', function () {
                beforeEach(function () {
                    nock_1.default.cleanAll();
                    nockLink(links.darwin, 302, { 'Location': 'http://example.com/redirect' });
                    nockLink(links.win32, 200);
                    nockLink(links.linux, 200);
                    nockLink(links.debian, 200);
                    nockLink('http://example.com/redirect', 200);
                });
                afterEach(function () {
                    if (!nock_1.default.isDone()) {
                        throw new Error('HTTP calls to link urls were not done');
                    }
                });
                it('does not throw if all the downloads are ok', function () { return __awaiter(void 0, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, expect_1.default(download_center_1.validateDownloadLinks(downloadCenterJson))
                                    .resolves.toBeUndefined()];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
            describe('with broken links', function () {
                beforeEach(function () {
                    nock_1.default.cleanAll();
                    nockLink(links.darwin, 200);
                    nockLink(links.win32, 302, { 'Location': 'http://example.com/redirect' });
                    nockLink(links.linux, 200);
                    nockLink(links.debian, 404);
                    nockLink('http://example.com/redirect', 404);
                });
                afterEach(function () {
                    if (!nock_1.default.isDone()) {
                        throw new Error('HTTP calls to link urls were not done');
                    }
                });
                it('throws reporting broken urls', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var error;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, (download_center_1.validateDownloadLinks(downloadCenterJson).catch(function (e) { return e; }))];
                            case 1:
                                error = _a.sent();
                                expect_1.default(error).not.toBeUndefined();
                                expect_1.default(error.message).toEqual('Download center urls broken:\n' +
                                    '- https://downloads.mongodb.com/compass/mongosh-0.2.2-win32.zip -> 404\n' +
                                    '- https://downloads.mongodb.com/compass/mongosh_0.2.2_amd64.deb -> 404');
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
            describe('probePlatformDownloadLink', function () {
                beforeEach(function () {
                    nock_1.default.cleanAll();
                    nockLink(links.linux, 200);
                    nockLink(links.debian, 404);
                });
                afterEach(function () {
                    if (!nock_1.default.isDone()) {
                        throw new Error('HTTP calls to link urls were not done');
                    }
                });
                it('returns the result of the probe', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var probe1, probe2;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, download_center_1.probePlatformDownloadLink({
                                    'arch': 'x64',
                                    'os': 'linux',
                                    'name': 'Linux 64-bit',
                                    'download_link': links.linux
                                })];
                            case 1:
                                probe1 = _a.sent();
                                expect_1.default(probe1.ok).toBe(true);
                                expect_1.default(probe1.status).toBe(200);
                                return [4 /*yield*/, download_center_1.probePlatformDownloadLink({
                                        'arch': 'x64',
                                        'os': 'debian',
                                        'name': 'Debian 64-bit',
                                        'download_link': links.debian
                                    })];
                            case 2:
                                probe2 = _a.sent();
                                expect_1.default(probe2.ok).toBe(false);
                                expect_1.default(probe2.status).toBe(404);
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
            after(nock_1.default.restore);
        });
    });
});
//# sourceMappingURL=download-center.spec.js.map