"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildInfo = void 0;
const os_1 = __importDefault(require("os"));
function buildInfo() {
    try {
        const buildInfo = { ...require('./build-info.json'), nodeVersion: process.version };
        delete buildInfo.segmentApiKey;
        return buildInfo;
    }
    catch (_a) {
        const { version } = require('../package.json');
        return {
            version,
            distributionKind: 'unpackaged',
            buildArch: os_1.default.arch(),
            buildPlatform: os_1.default.platform(),
            buildTarget: 'unknown',
            buildTime: null,
            gitVersion: null,
            nodeVersion: process.version
        };
    }
}
exports.buildInfo = buildInfo;
//# sourceMappingURL=build-info.js.map