"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.colorizeForStderr = exports.colorizeForStdout = void 0;
const ansi_escape_sequences_1 = __importDefault(require("ansi-escape-sequences"));
function colorize(text, style, options) {
    if (options.colors) {
        return ansi_escape_sequences_1.default.format(text, style);
    }
    return text;
}
exports.default = colorize;
function colorizeForStdout(text, style) {
    return colorize(text, style, {
        colors: process.stdout.isTTY && process.stdout.getColorDepth() > 1
    });
}
exports.colorizeForStdout = colorizeForStdout;
function colorizeForStderr(text, style) {
    return colorize(text, style, {
        colors: process.stderr.isTTY && process.stderr.getColorDepth() > 1
    });
}
exports.colorizeForStderr = colorizeForStderr;
//# sourceMappingURL=clr.js.map