import type { MongoshBus } from '@mongosh/types';
import { MongoLogWriter } from './log-writer';
interface MongoshAnalytics {
    identify(message: {
        userId: string;
        traits: {
            platform: string;
        };
    }): void;
    track(message: {
        userId: string;
        event: string;
        properties: {
            mongosh_version: string;
            [key: string]: any;
        };
    }): void;
}
export default function setupLoggerAndTelemetry(logId: string, bus: MongoshBus, makeLogger: () => MongoLogWriter, makeAnalytics: () => MongoshAnalytics): void;
export {};
