import './textencoder-polyfill';
import ServiceProvider, { ServiceProviderCore } from './service-provider';
import getConnectInfo, { ConnectInfo } from './connect-info';
import { ReplPlatform } from './platform';
import CliOptions from './cli-options';
import generateUri from './uri-generator';
declare const DEFAULT_DB = "test";
import { ObjectId, DBRef, MaxKey, MinKey, Timestamp, BSONSymbol, Code, Decimal128, Int32, Long, Binary, calculateObjectSize, Double, EJSON, BSONRegExp } from 'bson';
import { bsonStringifiers } from './printable-bson';
import ShellAuthOptions from './shell-auth-options';
export * from './all-transport-types';
export * from './all-fle-types';
import { isFastFailureConnectionError } from './fast-failure-connect';
declare const bson: {
    ObjectId: typeof ObjectId;
    DBRef: typeof DBRef;
    MaxKey: typeof MaxKey;
    MinKey: typeof MinKey;
    Timestamp: typeof Timestamp;
    BSONSymbol: typeof BSONSymbol;
    Code: typeof Code;
    Decimal128: typeof Decimal128;
    Int32: typeof Int32;
    Long: typeof Long;
    Binary: typeof Binary;
    Map: MapConstructor;
    calculateObjectSize: typeof calculateObjectSize;
    Double: typeof Double;
    EJSON: typeof EJSON;
    BSONRegExp: typeof BSONRegExp;
};
export { ServiceProvider, ShellAuthOptions, getConnectInfo, ReplPlatform, CliOptions, generateUri, DEFAULT_DB, ServiceProviderCore, bson, bsonStringifiers, ConnectInfo, isFastFailureConnectionError };
