import type { FindCursor as ServiceProviderCursor, Document, CollationOptions, ReadPreferenceLike, ReadConcernLevel, TagSet, HedgeOptions } from '@mongosh/service-provider-core';
import type Mongo from './mongo';
import { AbstractCursor } from './abstract-cursor';
export default class Cursor extends AbstractCursor<ServiceProviderCursor> {
    _tailable: boolean;
    constructor(mongo: Mongo, cursor: ServiceProviderCursor);
    private _addFlag;
    addOption(optionFlagNumber: number): Cursor;
    allowDiskUse(): Cursor;
    allowPartialResults(): Cursor;
    collation(spec: CollationOptions): Cursor;
    comment(cmt: string): Cursor;
    count(): Promise<number>;
    hasNext(): Promise<boolean>;
    hint(index: string): Cursor;
    limit(value: number): Cursor;
    max(indexBounds: Document): Cursor;
    maxAwaitTimeMS(value: number): Cursor;
    min(indexBounds: Document): Cursor;
    next(): Promise<Document | null>;
    noCursorTimeout(): Cursor;
    oplogReplay(): Cursor;
    readPref(mode: ReadPreferenceLike, tagSet?: TagSet[], hedgeOptions?: HedgeOptions): Cursor;
    returnKey(enabled: boolean): Cursor;
    size(): Promise<number>;
    tailable(opts?: {
        awaitData: boolean;
    }): Cursor;
    maxScan(): void;
    showRecordId(): Cursor;
    readConcern(level: ReadConcernLevel): Cursor;
}
