"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const decorators_1 = require("./decorators");
const cursor_1 = __importDefault(require("./cursor"));
const enums_1 = require("./enums");
let ExplainableCursor = class ExplainableCursor extends cursor_1.default {
    constructor(mongo, cursor, verbosity) {
        super(mongo, cursor._cursor);
        this._baseCursor = cursor;
        this._verbosity = verbosity;
        this._explained = null;
    }
    async [enums_1.asPrintable]() {
        var _a;
        (_a = this._explained) !== null && _a !== void 0 ? _a : (this._explained = await this._baseCursor.explain(this._verbosity));
        return this._explained;
    }
};
ExplainableCursor = __decorate([
    decorators_1.shellApiClassDefault
], ExplainableCursor);
exports.default = ExplainableCursor;
//# sourceMappingURL=explainable-cursor.js.map